config/routes.rb
Rails.application.routes.draw do
  resources :lottery_topics
  resources :posts
  resource :users,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :user_registration do
    get 'cancel'
  end

  devise_for :users, skip: [:registrations]
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root "home#index"
  resources :users do
    resource :reset_passwords
  end
  resources :admins
  resources :admins,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :admin_registration do
    get 'cancel'
  end
  resources :agents do 
    resources :member_invoices do
      resources :members do
        get '/confirmed', to: 'member_invoices#confirmed'
      end
    end
  end
  resources :members
  resources :profiles do
    resource :passwords
  end
  resources :lotteries
  resources :bills do
    resources :lotteries
    get '/confirmed', to: 'bills#confirmed'
  end

  resources :invoices

  get 'rood', to: 'lotteries#rood'
  get 'reverse', to: 'lotteries#reverse'
  get 'all_reverse', to: 'lotteries#all_reverse'
  get 'run', to: 'lotteries#run'
  get 'destroy_group', to: 'lotteries#destroy_group'

  get '/create_lottery', to: 'home#owner_lottery'
end

app/models/invoice.rb
class Invoice < ApplicationRecord
  belongs_to :user
  has_many :bills

  STATUS = {"wait" => 'รอชำระ', "paid" => 'ชำระแล้ว'}
end

app/controllers/invoices_controller.rb
class InvoicesController < ApplicationController

  def index
    @invoices = current_user.invoices
    if params[:search].present?
      if params[:search][:lot].present?
        @invoices = current_user.invoices.where(lottery_id: params[:search][:lot])
      else
        @invoices = current_user.invoices
      end

      if params[:search][:status].present?
        @invoices = @invoices.where(status: params[:search][:status])
      end

      if params[:search][:start_date].present? && params[:search][:end_date].present?
        start_date = params[:search][:start_date].to_date.beginning_of_day
        end_date = params[:search][:end_date].to_date.end_of_day
        @invoices = @invoices.where(:created_at => start_date..end_date)
      end
    end

    @invoices = @invoices.paginate(page: params[:page], per_page: 30).order('created_at DESC')
  end

  def show
    @invoice = current_user.invoices.find(params[:id])
  end
end

app/helpers/invoices_helper.rb
module InvoicesHelper
end

app/views/invoices/index.html.erb
<h1>สรุปยอดทั้งหมด</h1>

  
<%= form_tag invoices_path, method: :get do %>
  
  <div class="col-sm-6">
    <%= check_box_tag 'search[status][]', 'wait' %> <span class="text-uppercase">รอชำระ</span>
    <%= check_box_tag 'search[status][]', 'paid' %> <span class="text-uppercase">ชำระแล้ว</span>
    <br>
    <br>
    <% LotteryTopic.all.each do |lot| %>
      <%= check_box_tag 'search[lot][]', lot.title %> <span class="text-uppercase"><%= lot.name %></span>
    <% end %>
    <br>
    <br>
    <%= text_field_tag 'search[start_date]', '', class: 'datepicker'%> -
    <%= text_field_tag 'search[end_date]', '', class: 'datepicker'%>
     
    <%= submit_tag "ค้นหา", :disable_with => "Submitting...", class: 'btn btn-success btn-xs' %>
  </div>
<% end %>

<table class="table">
  <thead>
    <tr>
      <th>วันที่</th>
      <th></th>
      <th>รอบ</th>
      <th>สถานะ</th>
      <th>ยอดซื้อ</th>
      <th>ยอดถูก</th>
      <th>ส่วนลด</th>
      <th>สรุป</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @invoices.each do |invoice| %>
      <tr>
        <td><%= link_to invoice.created_at.to_date.strftime('%d/%m/%y'), invoice_url(invoice) %></td>
        <td><%= invoice.lottery_id %></td>
        <td><%= LotteryTime.set_lot_round(invoice.lottery_id, invoice.try(:round)) %></td>
        <td>
            <% if invoice.try(:status) == 'wait' %>
              <span class="label label-warning">รอชำระ</span>
            <% end %>
            <% if invoice.try(:status) == 'paid' %>
              <span class="label label-success">ชำระแล้ว</span>
            <% end %>
        </td>
        <td><%= invoice.total %></td>
        <td><%= invoice.amount_won %></td>
        <td><%= invoice.discount %></td>
        <td><%= invoice.try(:amount_total) %></td>
          <td class="manage">
            <% if current_user.avalability_agent? && !current_user.admin? %>
              <%= link_to 'ยืนยัน', invoice_confirmed_url(invoice), class: 'btn btn-success'%>
            <% end %>
          </td>
      </tr>
    <% end %>
    <tr>
      <th>รวม</th>
      <td></td>
      <td></td>
      <td></td>
      <td>
        <%= sprintf('%.1f', @invoices.map {|l| l.total.to_f }.sum) %>
      </td>
      <td>
        <%= sprintf('%.1f', @invoices.map {|l| l.amount_won.to_f }.sum) %>
      </td>
      <td>
        <%= sprintf('%.1f', @invoices.map {|l| l.discount.to_f }.sum) %>
      </td>
      <th>
        <%= sprintf('%.1f', @invoices.map {|l| l.amount_total.to_f }.sum) %>
      </th>
    </tr>
  </tbody>
</table>

<%= will_paginate @invoices, renderer: BootstrapPagination::Rails %>

<script type="text/javascript">
  $(document).ready(function(){
    $('.datepicker').datepicker({
      format: 'dd-mm-yyyy'
    });
  });
</script>

app/views/invoices/show.html.erb
<div class="container">
  <div class="jumbotron">
    <center>
      <h1>สรุปยอด</h1>
      <h4><%=@invoice.created_at.to_date.strftime('%d/%m/%y')%></h4>
      <h3><%= LotteryTime.set_lot_round(@invoice.lottery_id, @invoice.try(:round)) %></h3>
      <td>
        <% if @invoice.try(:status) == 'wait' %>
          <h3><span class="label label-warning">รอชำระ</span></h3>
        <% end %>
        <% if @invoice.try(:status) == 'paid' %>
          <h3><span class="label label-success">ชำระแล้ว</span></h3>
        <% end %>
      </td>
    </center>
    <br>

    <table class="table">
      <thead>
        <tr>
          <th>ยอดจริง</th>
          <th>ยอดซื้อ</th>
          <th>ถูกรางวัล</th>
          <th>ส่วนลด</th>
          <th>สรุป</th>
          <th>สู้เสีย</th>
          <th>ผลลัพธ์</th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td><%= @invoice.real_price %></td>
          <td><%= @invoice.total %></td>
          <td><%= @invoice.amount_won %></td>
          <td><%= @invoice.discount %></td>
          <td><%= @invoice.amount_total %></td>
          <td><%= @invoice.fight_paid %></td>
          <td><%= @invoice.result_amount %></td>
          <td>
            <%= link_to '#รายละเอียด', '#', id: 'invoice_description'%>
            <%= link_to '#ซ่อน', '#', id: 'invoice_description_close', class: 'hide'%>
            
          </td>
        </tr>
      </tbody>
    </table>

    <div class="invoice_bills hide">
      

      <table class="table" id="invoice_bills">
        <thead>
          <tr>
            <th>รอบ</th>
            <th>ชื่อ</th>
            <th>สถานะ</th>
            <th>ยอดซื้อ</th>
            <th>ถูกรางวัล</th>
            <th>ส่วนลด</th>
            <th>สรุป</th>
            <th>สู้เสีย</th>
            <th>ผลลัพธ์</th>
            <th></th>
          </tr>
        </thead>

        <tbody>
          <% @invoice.bills.each do |bill| %>
            <tr>
              <td><%= LotteryTime.set_lot_round(bill.lottery_id, bill.try(:round)) %></td>
              <td><%= bill.try(:name) %></td>
              <td>
                  <% if bill.try(:status) == 'draft' %>
                    <span class="label label-warning">รอยืนยัน</span>
                  <% end %>
                  <% if bill.try(:status) == 'confirmed' %>
                    <span class="label label-success">ยืนยันแล้ว</span>
                  <% end %>
                  <% if bill.try(:status) == 'active' %>
                    <span class="label label-success">ถูกรางวัล</span>
                  <% end %>
                  <% if bill.try(:status) == 'passive' %>
                    <span class="label label-danger">ไม่ถูกรางวัล</span>
                  <% end %>
              </td>
              <td><%= bill.try(:total) %></td>
              <td><%= bill.try(:amount_won) %></td>
              <td><%= bill.try(:discount) %></td>
              <td><%= bill.try(:amount_total) %></td>
              <td><%= bill.fight_paid %></td>
              <td><%= bill.result_amount %></td>
              <td><%= link_to '#รายละเอียด', '#', id: "bill_description", onclick: "add_event(#{bill.id})"%></td>

              </tr>
          <% end %>
        </tbody>
      </table>
    </div>
  </div>
</div>
<% @invoice.bills.each do |bill| %>
  <div class="modal fade modal_<%=bill.id%>" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel">
    <div class="modal-dialog modal-ld" role="document">
      <div class="modal-content">
        <table class="table">
          <thead>
            <tr>
              <th>เลข</th>
              <th></th>
              <th>ราคาจริง</th>
              <th>ราคา</th>
              <th>สถานะ</th>
              <th>รางวัล</th>
              <th>ส่วนลด</th>
              <th>สู้</th>
              <th>ราคาสู้</th>
              <th>สู้เสีย</th>
              <th>ผลลัพธ์</th>
              <th></th>
            </tr>
          </thead>

          <tbody>
            <% bill.lotteries.each do |lottery| %>
              <tr>
                <td><%= lottery.datum %></td>
                <td>
                  <%= 'บน' if lottery.position == "1" %>
                  <%= 'ล่าง' if lottery.position == "2" %>
                  <%= 'ตรง' if lottery.position == "4" %>
                  <%= 'โต๊ด' if lottery.position == "5" %>
                </td>
                <td><%= lottery.real_price %></td>
                <td><%= lottery.price %></td>
                <td>

                  <% if lottery.status == 'won' %>
                    <span class="label label-success">ถูกรางวัล</span>
                  <% elsif lottery.status == 'lose' %>
                    <span class="label label-danger">ไม่ถูกรางวัล</span>
                  <% else %>
                    <span class="label label-warning">รอออกรางวัล</span>
                  <% end %>
                </td>
                <td><%= lottery.won_amount %></td>
                <td><%= lottery.discount %></td>
                <td><%= lottery.fight_percent%>%</td>
                <td><%= lottery.fight_amount %></td>
                <td><%= lottery.fight_paid %></td>
                <td><%= lottery.result_amount %></td>

              </tr>
            <% end %>
            <tr>
              <th>รวม</th>
              <td></td>
              <th><%= bill.try(:real_price) %></th>
              <th><%= bill.try(:total).present? ? bill.try(:total) : 0 %></th>
              <td></td>
              <th><%= bill.try(:amount_won) %></th>
              <th><%= bill.try(:discount) %></th>
              <td></td>
              <td></td>
              <th><%= bill.try(:fight_paid) %></th>
              <th><%= bill.try(:result_amount) %></th>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
<% end %>



<script type="text/javascript">
  $( "#invoice_description" ).click(function(event) {
    event.preventDefault();
    $(this).addClass('hide');
    $("#invoice_description_close").removeClass('hide');
    $(".invoice_bills").removeClass('hide');
  });
  $( "#invoice_description_close" ).click(function(event) {
    event.preventDefault();
    $(this).addClass('hide');;
    $("#invoice_description").removeClass('hide');
    $(".invoice_bills").addClass('hide');
  });
  // $( "#bill_description" ).click(function() {
  //   $('.modal_1').modal('show')
  // });

  // $('#bill_description').click(add_event('shot'));
  function add_event(param) {
    event.preventDefault();
    $('.modal_'+param ).modal('show')
  }
</script>